import es
import vecmath
import cPickle
import time
import esamlib
import base64
import os
from configobj import ConfigObj
#Now it is required
import popuplib


addonpath = es.getAddonPath("distancemod")
gamedir = es.ServerVar("eventscripts_gamedir")
if os.path.isdir(addonpath + "/mapsettings") and os.path.isfile(addonpath + "/mapsettings/%s.ini" % es.ServerVar("eventscripts_currentmap")):
	distancesettings = ConfigObj(addonpath + "/mapsettings/%s.ini" % es.ServerVar("eventscripts_currentmap"))
else:
	distancesettings = ConfigObj(addonpath + "/weaponsettings.ini")


database = {}

try:
	database = cPickle.load(open(addonpath + "/database.db", "rb"))
except:
	pass
if not database.has_key("creationdate"):
	database["creationdate"] = time.strftime("%H:%M %d.%m.%Y")

info = es.AddonInfo()
info.name = "DistanceMod"
info.version = "1.1a"
info.author = "Brainsucker"
info.url = "http://addons.eventscripts.com"
info.description = "Gives a Player more Health if he makes a Kill with a high Distance to the Victim"

cmddict = {"rconcmds": {"dm_createmapconfig": "makenewcfg", "dm_useconfig": "setnewconfig", "dm_update": "updatecheck", "dm_dbcreationdate": "telldbdate", "dm_resetdbwithbackup": "resetdbbackup", "dm_resetdb": "resetdb"}, "consolecommands": {"dm_author": "tellauthor", "dm_url": "tellurl"}, "chatcommands": {"!dm_statistic": "tellstats"}}
cmdlist = []
requiredkeys = {"archives": {"distancekills": int(), "distance": float(), "lowestdistance": int(), "highestdistance": int(), "lowestdistanceweapon": str(), "highestdistanceweapon": str()}}

def keycheck(keyname):
	if database.has_key(keyname):
		if keyname != "creationdate":
			for x in requiredkeys:
				if not database[keyname].has_key(x):
					database[keyname][x] = requiredkeys[x]
				for y in requiredkeys[x]:
					if not database[keyname][x].has_key(y):
						database[keyname][x][y] = requiredkeys[x][y]

def tellstats():
	userid = es.getcmduserid()
	cvar = int(es.ServerVar("sv_lan"))
	if not cvar:
		u = es.getplayersteamid(userid)
	else:
		u = es.createplayerlist(userid)[int(userid)]["address"].split(":")[0]
	if database.has_key(u):
		popuplib.quicksend(30, userid, "DistanceMod Statistics for %s:\n---\nDistanced Kills: %s\nDistance of all DistancedKills: %s Meter\nAvagerage Distance: %s Meter\nLowest Distance: %s Meter (with Weapon %s)\nHighest Distance: %s Meter (with Weapon %s)" % (es.getplayername(userid), database[u]["archives"]["distancekills"], round((database[u]["archives"]["distance"]*0.0254), 2), round((database[u]["archives"]["distance"]*0.0254)/database[u]["archives"]["distancekills"], 2) , round((database[u]["archives"]["lowestdistance"], 2*0.0254), 2), database[u]["archives"]["lowestdistanceweapon"].upper(), round((database[u]["archives"]["highestdistance"]*0.0254), 2), database[u]["archives"]["highestdistanceweapon"].upper()))
	else:
		es.tell(userid, "[DistanceMod] You are not in the Database yet.")

def updatecheck():
	if not int(es.ServerVar("sv_lan")):
		q = esamlib.getAddon("distancemod")
		try:
			newest_version = q.currentversion
		except:
			es.dbgmsg(0, "[DistanceMod] Not possbile to connect to Page!")
		if str(info["version"]) != str(newest_version):
			es.log("[DistanceMod] Your current AddonVersion is out of Date. Please update it at %s" % info["url"])
		else:
			es.dbgmsg(0, "[DistanceMod] No Update required!")
			
def resetdb():
	global database
	database = {"creationdate": time.strftime("%H:%M %d.%m.%Y")}
	cPickle.dump(database, open(addonpath + "/database.db", "wb"))
	
def resetdbbackup():
	global database
	cPickle.dump(database, open(addonpath + "/database_backup.db", "wb"))
	database = {"creationdate": time.strftime("%H:%M %d.%m.%Y")}
	cPickle.dump(database, open(addonpath + "/database.db", "wb"))

def telldbdate():
	if database.has_key("creationdate"):
		splitdate = database["creationdate"].split()
		es.dbgmsg(0, "[DistanceMod] The Database was created on %s at %s" % (splitdate[1], splitdate[0]))
	else:
		es.dbgmsg(0, "[DistanceMod] No Database exist!")

def tellurl():
	userid = es.getcmduserid()
	if userid:
		es.tell(userid, "[DistanceMod] You can get this Addon at %s" % info["url"])
	else:
		es.dbgmsg(0, "[DistanceMod] You can get this Addon at %s" % info["url"])

def tellauthor():
	userid = es.getcmduserid()
	if userid:
		es.tell(userid, "[DistanceMod] This Addon is made by %s" % info["author"])
	else:
		es.dbgmsg(0, "[DistanceMod] This Addon is made by %s" % info["author"])

def setnewconfig():
	global distancesettings
	if es.getargc() == 2:
		e = es.getargv(1)
		if not e.endswith(".ini"):
			e += ".ini"
		if os.path.isfile(addonpath + "/" + e):
			distancesettings = ConfigObj(addonpath + "/" + e)
			es.dbgmsg(0, "[DistanceMod] Now using %s as active ConfigFile" % e)

def makenewcfg():
	tempcfg = ConfigObj(addonpath + "/weaponsettings.ini")
	if not os.path.isdir(addonpath + "/mapsettings"):
		os.mkdir(addonpath + "/mapsettings")
	if es.getargc() > 1:
		if es.getargv(1).lower() == "#allmaps":
			for m in os.listdir(gamedir + "/maps"):
				if not os.path.isfile(addonpath + "/mapsettings/%s.ini" % m.rsplit(".", 1)[0]):
					if m.endswith(".bsp"):
						q = ConfigObj()
						q.filename = "%s/mapsettings/%s.ini" % (addonpath, m.rsplit(".", 1)[0])
						for z in tempcfg:
							q[z] = tempcfg[z]
						q.write()
			return
		p = es.getargs().split()
		for a in p:
			if os.path.isfile(gamedir + "/maps/%s.bsp" % a):
				q = ConfigObj()
				q.filename = "%s/mapsettings/%s.ini" % (addonpath, a)
				for z in tempcfg:
					q[z] = tempcfg[z]
				q.write()
		return
	if not os.path.isfile(addonpath + "/mapsettings/%s.ini" % es.ServerVar("eventscripts_currentmap")):
		q = ConfigObj()
		q.filename = "mapsettings/%s.ini" % es.ServerVar("eventscripts_currentmap")
		for z in tempcfg:
			q[z] = tempcfg[z]
		q.write()

def load():
	if info["author"] == base64.decodestring("QnJhaW5zdWNrZXI=\n"):
		for x in cmddict["rconcmds"]:
			if not es.exists("command", x):
				es.regcmd(x, "distancemod/%s" % cmddict["rconcmds"][x])
		for y in cmddict["consolecommands"]:
			if not es.exists("clientcommand", y):
				es.regclientcmd(y, "distancemod/%s" % cmddict["consolecommands"][y])
				cmdlist.append(y + " (Console)")
		for z in cmddict["chatcommands"]:
			if not es.exists("saycommand", z):
				es.regsaycmd(z, "distancemod/%s" % cmddict["chatcommands"][z])
				cmdlist.append(z + " (Chat)")
		if popuplib.exists("distancemod_helppopup"):
			popuplib.delete("distancemod_helppopup")
		hpopup = popuplib.easylist("distancemod_helppopup", cmdlist)
		hpopup.settitle("Avaliable Commands for DistanceMod:")
		updatecheck()
		es.ServerVar(info["name"], info["version"]).makepublic()
		if len(database) > 1:
			t1 = time.time()
			es.dbgmsg(0, "Checking and Updating Database!")
			for key in database:
				keycheck(key)
			t2 = time.time()
			es.dbgmsg(0, "Finished Updating Database in %f Seconds" % (float(t2)-float(t1)))
	else:
		es.unload("distancemod")
		
def unload():
	for y in cmddict["consolecommands"]:
		if es.exists("clientcommand", y):
			es.unregclientcmd(y)
			cmdlist.remove(y + " (Console)")
	for z in cmddict["chatcommands"]:
		if es.exists("chatcommand", z):
			es.unregsaycmd(z)
			cmdlist.remove(z + " (Chat)")

def player_death(ev):
	attacker = ev["attacker"]
	user = ev["userid"]
	cvar = int(es.ServerVar("sv_lan"))
	if not cvar:
		u = ev["es_attackersteamid"]
	else:
		u = es.createplayerlist(attacker)[int(attacker)]["address"].split(":")[0]
	if ev["es_userteam"] != ev["es_attackerteam"] and not u in ["STEAM_ID_PENDING", "BOT"]:
		if not database.has_key(u):
			database[u] = {}
			keycheck(u)
		weapon = ev["weapon"]
		w = weapon.replace("weapon_", "").lower()
		if distancesettings.has_key(w):
			attackerloc = es.getplayerlocation(attacker)
			userloc = es.getplayerlocation(user)
			_distance = vecmath.distance(userloc, attackerloc)
			if float(distancesettings[w]["min_distance"])*0.0254 < _distance:
				add_life = round((int(_distance)-(float(distancesettings[w]["min_distance"])*39))/133)
				if add_life > 0:
					if distancesettings[w].has_key("multiplier"):
						add_life = int(float(add_life)*float(distancesettings[w]["multiplier"]))
					es.setplayerprop(attacker, "CCSPlayer.baseclass.m_iHealth", es.getplayerprop(attacker, "CCSPlayer.baseclass.m_iHealth") + add_life)
					es.tell(attacker, "#multi", "[DistanceMod] You killed #green%s #defaultfrom a high Distance (#green%f Meter#default) with the Weapon #green%s#default. You get additional #green%i #defaultHP" % (ev["es_username"], round(_distance*0.0254, 2), w.capitalize(), add_life))
				database[u]["archives"]["distancekills"] += 1
				database[u]["archives"]["distance"] += _distance
				if database[u]["archives"]["lowestdistance"]:
					if database[u]["archives"]["lowestdistance"] > _distance:
						database[u]["archives"]["lowestdistance"] = _distance
						database[u]["archives"]["lowestdistanceweapon"] = weapon
				else:
					database[u]["archives"]["lowestdistance"] = _distance
					database[u]["archives"]["lowestdistanceweapon"] = weapon
				if database[u]["archives"]["highestdistance"]:
					if database[u]["archives"]["highestdistance"] < _distance:
						database[u]["archives"]["highestdistance"] = _distance
						database[u]["archives"]["highestdistanceweapon"] = weapon
				else:
					database[u]["archives"]["highestdistance"] = _distance
					database[u]["archives"]["highestdistanceweapon"] = weapon
					
def es_map_start(ev):
	global distancesettings
	if os.path.isdir(addonpath + "/mapsettings"):
		if os.path.isfile(addonpath + "/mapsettings/%s.ini" % ev["mapname"]):
			distancesettings = ConfigObj(addonpath + "/mapsettings/%s.ini" % ev["mapname"])
		else:
			distancesettings = ConfigObj(addonpath + "/weaponsettings.ini")
			
def round_end(ev):
	cPickle.dump(database, open(addonpath + "/database.db", "wb"))


def player_say(ev):
	text = ev["text"]
	if text.lower() == "!dm_help":
		popuplib.send("distancemod_helppopup", ev["userid"])